// H8_LAN sample program

#include <h8/reg3067.h>
#include <h8/syscall.h>
#include <string.h>
#include "h8_lan.h"

#define DEBUG_COMMAND	0
#define DEBUG_PRINT		1

#if DEBUG_PRINT
#define		DbgPrint(_x_)		MyPrint(_x_)
#define		DbgPrintBin(_x_)	MyPrintBinary(_x_)
#else
#define		DbgPrint(_x_)
#define		DbgPrintBin(_x_)
#endif


void MyPrint(char *pMsg)
{
	write_mode(ASCII);
	write_string(pMsg);
}

void MyPrintBinary(char *pMsg)
{
	write_mode(BINARY);
	sys_write(pMsg, 1);
}

/********************************************************************************/

int GetInitState(void)
{
	return ImageInitial;
}

int ClearAction(void)
{
	g_NowAction = 0;
}

int GetCameraState(void)
{
	return g_CameraState;
}

void IncrementDataCount(void)
{
	imatge_data_count++;
}

unsigned long GetTotalImageSize(void)
{
	return imatge_data_length;
}

//////////////////////////////////////////////////
//
// VAJɃR}h𑗐M
//
//////////////////////////////////////////////////
unsigned char Send_Cmd (
		unsigned char cmd, 
		unsigned char param1, 
		unsigned char param2, 
		unsigned char param3, 
		unsigned char param4)
{
	unsigned char	bRet = C1098_FALSE;
	int				iLen;
	char			*pBuf = NULL;
	
	SendCmd.Sync	= 0xAA;
	SendCmd.CmdID	= cmd;
	SendCmd.Param1	= param1;
	SendCmd.Param2	= param2;
	SendCmd.Param3	= param3;
	SendCmd.Param4	= param4;

	iLen = sizeof(comedia_C1098_CMD);
	pBuf = (char *)&SendCmd;

	// ݂郂[hw
	write_mode(BINARY);
	if (sys_write(pBuf, iLen) != 0) {
		bRet = C1098_TRUE;
	}
	return bRet;
}

//////////////////////////////////////////////////
//
// VAJR}hM
//
//////////////////////////////////////////////////
unsigned char Recv_Cmd (
			char *buf, 
			long length)
{
	unsigned char bRet = C1098_FALSE;

	if (sys_read(buf, length) != 0) {
		bRet = C1098_TRUE;
	}
	return bRet;
}


//////////////////////////////////////////////////
//
// VAJɃZbgR}h𑗐M
//
//////////////////////////////////////////////////
unsigned char Send_Reset_Cmd( void )
{
	unsigned char bRet = C1098_FALSE;
	
	while (bRet == C1098_FALSE) {
		if (Send_Cmd (C1098_CMD_RESET, 0x00, 0x00, 0x00, 0xff) == C1098_TRUE) {
			sleep( 2 );
			if (Recv_Cmd ((char*)&RcvCmd, sizeof(comedia_C1098_CMD)) == C1098_TRUE) {
				if (RcvCmd.CmdID == C1098_CMD_ACK) {
					bRet = C1098_TRUE;
				} else {
					imagereset++;
				}
			} else {
				imagereset++;
			}
		} else {
			imagereset++;
		}
	}
	return bRet;
}

//////////////////////////////////////////////////
//
// VAJɓR}h𑗐M
//
//////////////////////////////////////////////////
unsigned char Send_SYNC_Cmd (void)
{
	unsigned char bRet = C1098_FALSE;
	int i = 0;

	DbgPrint("Send_SYNC_Cmd done\n");
	
	// {́Å֐œNGXg𔭍sĂ܂A
	// ́Albg[N̓t[邽߂ɏ폜Ă܂B
	return C1098_TRUE;
}

unsigned char Send_SetPackageSize_Cmd (unsigned short size)
{
	unsigned char bRet = C1098_FALSE;
	
	// {́Å֐ŃpPbgTCỸNGXg𔭍sĂ܂A
	// ́Albg[N̓t[邽߂ɏ폜Ă܂B
	
	DbgPrint("Send_SetPackageSize_Cmd done\n");
	return C1098_TRUE;
}


#define DEFAULET_PACKAGE_SIZE ((unsigned short)512)

unsigned char Send_Initial_Cmd (unsigned char resolution)
{
	// {́Å֐ŏNGXg𔭍sĂ܂A
	// ́Albg[N̓t[邽߂ɏ폜Ă܂B
	DbgPrint("dummy init command ok\n");
	return C1098_TRUE;
}


int SendInitCmd(void)
{
	unsigned char	resolution = C1098_RESOLUTION_640x480;
	long			lValue = 0;
	unsigned char	bRet = C1098_FALSE;

	ImageInitial = 0;
	
	// NGXg𔭍s
	Send_SYNC_Cmd();

	// NGXg𔭍s
	bRet = Send_Initial_Cmd(resolution);
	if (bRet != C1098_TRUE) {
		DbgPrint("Send_Initial_Cmd fail\n");
		ImageInitial = 0;
		return C1098_FALSE;
	}
	bRet = Send_SetPackageSize_Cmd(DEFAULET_PACKAGE_SIZE);
	if (bRet != C1098_TRUE) {
		DbgPrint("Send_SetPackageSize_Cmd fail\n");
		ImageInitial = 0;
		return C1098_FALSE;
	}
	ImageInitial = 2;
	Image_resolution = C1098_RESOLUTION_640x480;
	Image_picttype = C1098_PICTTYPE_SNAPSHOT;
	Image_snaptype = C1098_SNAPTYPE_COMPRESS;
	Image_packsize = 0x200;
	
	return bRet;
}



unsigned char StartSnapshot(void)
{
	unsigned char bRet = C1098_FALSE;

	// {́Å֐ŃXibvVbgNGXg𔭍sĂ܂A
	// ́Albg[N̓t[邽߂ɏ폜Ă܂B
	
	return C1098_TRUE;
}


/********************************************************************************/


static char ctrl_buf[H8_CTRL_BUFF_SIZE];

static long H8CtrlC1098Init(int sock)
{
	unsigned char	bRet = C1098_FALSE;
	
	// request init command
	bRet = SendInitCmd();
	
	ClearAction();
	
	((H8_CONTROL_PACKET *) ctrl_buf)->CommandCode |= H8_RES_MASK;
	((H8_CONTROL_PACKET *) ctrl_buf)->Status = bRet;
	((H8_CONTROL_PACKET *) ctrl_buf)->TotalPacketCount = 1;
	((H8_CONTROL_PACKET *) ctrl_buf)->CurrentPacketCount = 0;
	((H8_CONTROL_PACKET *) ctrl_buf)->TotalDataLen = 0;
	((H8_CONTROL_PACKET *) ctrl_buf)->DataType = 0;
	((H8_CONTROL_PACKET *) ctrl_buf)->CurrentDataLen = 0;
	tcp_write(sock, ctrl_buf, sizeof(H8_CONTROL_PACKET));
	return 0;
}


static long H8CtrlC1098GetPicture(int sock)
{
	int				iRet = 0;
	int				iInit = 0;
	unsigned long	lRemainBytes = 0, 
					lSendSize = 0;
	unsigned short	wReadSize = 0;
	unsigned char	*buf_tx = NULL;
	
	iInit = GetInitState();
	if ( iInit == 2) {
		// send snapshot command
		iRet = StartSnapshot();
		if (iRet) {
			// set total bytes
			lRemainBytes = GetTotalImageSize();	
			((H8_CONTROL_PACKET *) ctrl_buf)->CommandCode |= H8_RES_MASK;
			((H8_CONTROL_PACKET *) ctrl_buf)->Status = iRet;
			((H8_CONTROL_PACKET *) ctrl_buf)->TotalPacketCount = 1;
			((H8_CONTROL_PACKET *) ctrl_buf)->CurrentPacketCount = 0;
			((H8_CONTROL_PACKET *) ctrl_buf)->TotalDataLen = lRemainBytes;
			((H8_CONTROL_PACKET *) ctrl_buf)->DataType = 0;
			((H8_CONTROL_PACKET *) ctrl_buf)->CurrentDataLen = lRemainBytes;
			
			tcp_write(sock, ctrl_buf, sizeof(H8_CONTROL_PACKET));
			
			buf_tx = (unsigned char *)malloc(2048);
			
			if (buf_tx == NULL) {
				DbgPrint("can't allocate mem\n");
				return 0;
			}

			// ۂ͂JPEGf[^̓ǂݏo`Ă܂A
			// ́Albg[N̓t[邽߂ɏ폜Ă܂B
			
			iRet = H8_SUCCESS;
			DbgPrint("H8CtrlC1098GetPicture: read done!!\n");
			if (buf_tx != NULL)
				free(buf_tx);
		}
	} else {
		DbgPrint("H8CtrlC1098GetPicture: need init!!\n");
		((H8_CONTROL_PACKET *) ctrl_buf)->CommandCode |= H8_RES_MASK;
		((H8_CONTROL_PACKET *) ctrl_buf)->Status = H8_FAIL;
		((H8_CONTROL_PACKET *) ctrl_buf)->TotalPacketCount = 1;
		((H8_CONTROL_PACKET *) ctrl_buf)->CurrentPacketCount = 0;
		((H8_CONTROL_PACKET *) ctrl_buf)->TotalDataLen = lRemainBytes;
		((H8_CONTROL_PACKET *) ctrl_buf)->DataType = 0;
		((H8_CONTROL_PACKET *) ctrl_buf)->CurrentDataLen = 0;
		tcp_write(sock, ctrl_buf, sizeof(H8_CONTROL_PACKET));
	}	
	return 0;
}


static int	iBlockFlag = 0;
static int	g_Cnt = 0;

int CommandeRecv(int flag, int sock, struct sockaddr_in *addr) {
	char buffer[256];
	int  len, ctrlen, iRet = 0;
	unsigned char	*p;

	switch(flag) {
		case TCP_BEGIN:
			DbgPrint("connect\n");
			break;

		case TCP_DATA:
			
			if (iBlockFlag == 1) {
				DbgPrint("Now working ...\n");
				return -1;
			}
			
			DbgPrint("CommandeRecv\n");
			
			// r
			iBlockFlag = 1;
			// Mf[^ǂݏo܂
			len = tcp_read(buffer, 255);
			
			if (len == -1) {
				return -1;
			}
				
			if (len > 0) {
				if (len > H8_CTRL_BUFF_SIZE) {
					DbgPrint("invalid packet length:");
					
					p = (unsigned char*)&len;
					// pPbg\
					p = (unsigned char*)&ctrlen;
					DbgPrintBin((unsigned char *)&p[0]);
					DbgPrintBin((unsigned char *)&p[1]);
					DbgPrintBin((unsigned char *)&p[2]);
					DbgPrintBin((unsigned char *)&p[3]);
					DbgPrint(" / ");
					ctrlen = H8_CTRL_BUFF_SIZE;
					p = (unsigned char*)&ctrlen;
					DbgPrintBin((unsigned char *)&p[0]);
					DbgPrintBin((unsigned char *)&p[1]);
					DbgPrintBin((unsigned char *)&p[2]);
					DbgPrintBin((unsigned char *)&p[3]);
					DbgPrint("\n");
				}
				
				// Mf[^Rs[
				memcpy(ctrl_buf, buffer, len);
				// MAhXZbg
				set_tcpaddr(addr, CTRL_PORT);
				
				switch (((H8_CONTROL_PACKET *) ctrl_buf)->CommandCode) {
					case C1098_INIT:
						DbgPrint("C1098_INIT\n");
						iRet = H8CtrlC1098Init(sock);
						break;
					case C1098_GET_PICTURE:
						DbgPrint("C1098_GET_PICTURE\n");
						iRet = H8CtrlC1098GetPicture(sock);
						break;
					default:
						DbgPrint("unknown command!!\n");
						break;
				}
			}
			iBlockFlag = 0;
			break;
		case TCP_CLOSE:
			DbgPrint("disconnect\n");
			tcpclose(sock);
			break;
	}
	return 0;
}

int tcp(unsigned short port, struct sockaddr_in *addr, unsigned char flag, int seq) {
	int sock;

	// M|[gԍ𔻕
	if(port != CTRL_PORT) {
		return -1;
	}
	
	// ZbgtȌꍇ͐ؒf
	if(flag & RST) {
		return -1;
	}
	
	// ڑv̏ꍇؒf
	if(!(flag & SYN)) {
		return -1;
	}
	
	// R}hʏɎMpPbgn
	sock = tcpsocket(seq, CommandeRecv);
	write_string("tcp connect done!!\n");

	return 0;
}

int main(void) 
{	
	
	ether_init(0x200000);
	if(get_ether_status() == 0) {
		return -1;
	}
	ip_setup(IPADDR(192,168,0,145), IPADDR(255,255,255,0));
	tcp_regport(tcp);
	
	// VA|[g
	sio_speed(57600, FREQ);

	write_string("Server start!!\n");

	// loop
	while(1) {
		;
	}
}

